import React from 'react';
import { Icon, Form, Button, Input, Select, Spin, Table, DatePicker, message, Modal, Upload, Radio } from 'antd';
import { technologyStateList } from '../../../dataDic.js';
import { getTechnologyState, beforeUpload, beforeUploadFile, techDownloadFile, getPreview, companySearch } from '../../../tools.js';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';

const ApplyChangeFrom = Form.create()(React.createClass({
    loadData(id) {
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/techproject/techProjectDetial",
            data: {
                pid: id || this.props.data.id
            },
            success: function (data) {
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                    return;
                };
                this.state.data = data.data;
                this.state.moneyType = undefined;
                if (data.data.projectMode == 1) {
                    this.state.projectMode = data.data.projectMode;
                    this.setState({ moneyType: 2 });
                };
                if (data.data.subsidy == 1) {
                    this.state.subsidy = data.data.subsidy;
                    this.setState({ moneyType: 1 });
                };
                this.getContactsList();
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getStateData(id) {
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/techproject/techProjectLog",
            data: {
                pid: id || this.props.data.id
            },
            success: function (data) {
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                    return;
                };
                var myDate = new Date();
                this.state.stateTable = [];
                for (let i = 0; i < data.data.length; i++) {
                    this.state.stateTable.push({
                        key: i,
                        state: data.data[i].state,
                        recordTime: data.data[i].recordTime,
                        recordTimeFormattedDate: data.data[i].recordTimeFormattedDate,
                        principal: data.data[i].principal,
                        operator: data.data[i].operator,
                        comment: data.data[i].comment
                    });
                };
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getContactsList(id) {
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/getContacts",
            data: { "uid": id || this.props.data.uid },
            success: function (data) {
                let theOption = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                    return;
                };
                for (let item in data.data) {
                    let theData = data.data[item];
                    theOption.push(
                        <Select.Option value={item} key={item}>{theData}</Select.Option>
                    );
                };
                this.setState({
                    contactsOption: theOption
                });
            }.bind(this),
        });
    },
    getDepartmentList(id) {
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/techproject/getDepartment",
            data: { "uid": id || this.props.data.uid },
            success: function (data) {
                let theOption = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                    return;
                };
                for (let item in data.data) {
                    let theData = data.data[item];
                    theOption.push(
                        <Select.Option value={item} key={item}>{theData}</Select.Option>
                    );
                };
                this.setState({
                    departmentOption: theOption,
                });
            }.bind(this),
        });
    },
    getOptionList() {
        this.setState({
            loading: true
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + "/api/admin/techproject/status",
            success: function (data) {
                let _me = this;
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                        return;
                    };
                };
                _me.state.stateOption = [];
                for (var item in data.data) {
                    _me.state.stateOption.push(
                        <Select.Option value={item} key={item}>{data.data[item]}</Select.Option>
                    )
                };
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
            loading: false,
            stateOption: [],
            projectDes: '',
            projectMode: 0,
            subsidy: 0,
            projectModeState: false,
            subsidyState: false,
            stateColumns: [{
                title: '科技项目状态',
                dataIndex: 'state',
                key: 'state',
                render: (text) => { return getTechnologyState(text) }
            }, {
                title: '处理时间',
                dataIndex: 'recordTimeFormattedDate',
                key: 'recordTimeFormattedDate'
            }, {
                title: '负责人',
                dataIndex: 'principal',
                key: 'principal',
            }, {
                title: '操作人',
                dataIndex: 'operator',
                key: 'operator',
            }, {
                title: '备注',
                dataIndex: 'comment',
                key: 'comment',
            }],
            stateTable: []
        };
    },
    componentWillMount() {
        this.loadData();
        this.getOptionList();
        this.getStateData();
        this.getContactsList();
        this.getDepartmentList();
    },
    handleSubmit(e) {
        e.preventDefault();
        this.props.form.validateFields((err, values) => {
            if (values.state || values.principal || values.recordTime || values.comment) {
                if (!values.state || !values.principal || !values.recordTime) {
                    message.warning("请填写完整的状态流转信息！");
                    return;
                };
            };
            if (!err) {
                this.props.spinState(true);
                let contacts = !isNaN(values.contacts) ? values.contacts : this.state.data.contacts;
                $.ajax({
                    method: "POST",
                    dataType: "json",
                    crossDomain: false,
                    url: globalConfig.context + "/api/admin/techproject/updateTechProject",
                    data: {
                        id: this.props.data.id,
                        uid: this.props.data.uid,
                        contacts: contacts,
                        department: values.department,
                        projectName: values.projectName,
                        projectCatagory: values.projectCatagory,
                        techField: values.techField,
                        projectDes: values.projectDes,
                        projectMode: this.state.projectMode,
                        projectApproval: values.projectApproval,
                        subsidy: this.state.subsidy,
                        approvalUrl: this.state.approvalUrl,
                        recordTimeFormattedDate: values.recordTime ? values.recordTime.format("YYYY-MM-DD HH:mm:ss") : undefined,
                        state: values.state,
                        principal: values.principal,
                        comment: values.comment,
                    }
                }).done(function (data) {
                    if (!data.error.length) {
                        message.success('保存成功！');
                        this.props.closeModal();
                        this.props.form.resetFields();
                        this.props.spinState(false);
                    } else {
                        message.warning(data.error[0].message);
                        this.props.spinState(false);
                    }
                }.bind(this));
            }
        });
    },
    componentWillReceiveProps(nextProps) {
        if (!this.props.visible && nextProps.visible) {
            this.state.fileList = [];
            this.loadData(nextProps.data.id);
            this.getStateData(nextProps.data.id);
            this.getContactsList(nextProps.data.uid);
            this.getDepartmentList(nextProps.data.uid);
            this.state.approvalUrl = undefined;
            this.state.subsidy = undefined;
            this.props.form.resetFields();
        };
    },
    subsidyCheck(e) {
        if (e.target.value == 1) {
            this.state.subsidy = 1;
            this.state.projectMode = 0;
        } else if (e.target.value == 2) {
            this.state.subsidy = 0;
            this.state.projectMode = 1;
        };
        this.setState({
            moneyType: e.target.value
        });
    },
    render() {
        const FormItem = Form.Item;
        const { getFieldDecorator } = this.props.form;
        const theData = this.state.data;
        const formItemLayout = {
            labelCol: { span: 6 },
            wrapperCol: { span: 12 },
        };
        const _me = this;
        if (this.state.data) {
            return (
                <Form onSubmit={this.handleSubmit} id="highTechApply-form">
                    <div className="clearfix">
                        <div className="half-item">
                            <span className="item-title">公司名称: </span>
                            <span>{theData.unitName}</span>
                        </div>
                        <div className="half-item">
                            <span className="item-title">组织机构代码 : </span>
                            <span>{theData.orgCode}</span>
                        </div>
                        <div className="half-item">
                            <span className="item-title">公司地址: </span>
                            <span>{theData.postalAddress}</span>
                        </div>
                        <div className="half-item">
                            <FormItem
                                labelCol={{ span: 5 }}
                                wrapperCol={{ span: 10 }}
                                label="联系人:"
                            >
                                {getFieldDecorator('contacts', {
                                    initialValue: this.state.data.contacts
                                })(
                                    <Select>{this.state.contactsOption}</Select>
                                    )}
                            </FormItem>
                        </div>
                    </div>
                    <div>
                        <div className="item-title">状态流转记录: </div>
                        <Table style={{ background: "#eee", margin: "10px 0" }}
                            pagination={false}
                            dataSource={this.state.stateTable}
                            columns={this.state.stateColumns} />
                        <div className="clearfix" style={{ paddingLeft: '4px', paddingTop: '10px', background: "#eee" }}>
                            <FormItem className="half-item"
                                {...formItemLayout}
                                label="状态流转"
                            >
                                {getFieldDecorator('state')(
                                    <Select
                                        style={{ width: 200 }}
                                        placeholder="选择一个状态">
                                        {this.state.stateOption}
                                    </Select>
                                )}
                            </FormItem>
                            <FormItem className="half-item"
                                {...formItemLayout}
                                label="处理时间"
                            >
                                {getFieldDecorator('recordTime')(
                                    <DatePicker />
                                )}
                            </FormItem>
                            <FormItem className="half-item"
                                {...formItemLayout}
                                label="负责人"
                            >
                                {getFieldDecorator('principal')(
                                    <Select
                                        showSearch
                                        filterOption={companySearch}
                                        placeholder="选择负责人">
                                        {this.props.authorOption}
                                    </Select>
                                )}
                            </FormItem>
                            <FormItem className="half-item"
                                {...formItemLayout}
                                label="备注">
                                {getFieldDecorator('comment')(
                                    <Input />
                                )}
                            </FormItem>
                        </div>
                    </div>
                    <div className="clearfix">
                        <FormItem className="third-item"
                            {...formItemLayout}
                            label="科技部门"
                        >
                            {getFieldDecorator('department', {
                                initialValue: theData.department
                            })(
                                <Select style={{ width: 400 }}
                                    notFoundContent='无科技部门可选'
                                    showSearch
                                    filterOption={companySearch}
                                    placeholder='请输入科技部门' >
                                    {this.state.departmentOption}
                                </Select>
                                )}
                        </FormItem>
                    </div>
                    <div className="clearfix">
                        <div className="half-item">
                            <FormItem
                                labelCol={{ span: 4 }}
                                wrapperCol={{ span: 12 }}
                                label="项目名称"
                            >
                                {getFieldDecorator('projectName', {
                                    initialValue: theData.projectName
                                })(
                                    <Input />
                                    )}
                            </FormItem>
                        </div>
                    </div>
                    <div className="clearfix">
                        <div className="half-item">
                            <FormItem
                                labelCol={{ span: 4 }}
                                wrapperCol={{ span: 12 }}
                                label="项目类型"
                            >
                                {getFieldDecorator('projectCatagory', {
                                    initialValue: theData.projectCatagory
                                })(
                                    <Input />
                                    )}
                            </FormItem>
                        </div>
                    </div>
                    <div className="clearfix">
                        <div className="half-item">
                            <FormItem
                                labelCol={{ span: 4 }}
                                wrapperCol={{ span: 12 }}
                                label="技术领域"
                            >
                                {getFieldDecorator('techField', {
                                    initialValue: theData.techField
                                })(
                                    <Input />
                                    )}
                            </FormItem>
                        </div>
                    </div>
                    <div className="clearfix">
                        <span className="item-title">项目简介: </span>
                        {getFieldDecorator('projectDes', {
                            initialValue: theData.projectDes
                        })(
                            <Input type="textarea"
                                placeholder="多行输入"
                                rows={6} />
                            )}
                    </div>
                    <div className="clearfix">
                        <div className="half-item">
                            <span className="item-title">立项/后补助: </span>
                            <Radio.Group value={this.state.moneyType} onChange={this.subsidyCheck}>
                                <Radio value={1}>立项</Radio>
                                <Radio value={2}>后补助</Radio>
                            </Radio.Group>
                        </div>
                        <div className="half-item">
                            <FormItem
                                {...formItemLayout}
                                label='金额'
                            >
                                {getFieldDecorator('projectApproval', {
                                    initialValue: theData.projectApproval
                                })(
                                    <Input style={{ width: 200 }} />
                                    )}
                                <span>万元</span>
                            </FormItem>
                        </div>
                    </div>
                    <div className="hrSituation-roster">
                        <Upload
                            name="avatar"
                            action={globalConfig.context + "/api/admin/techproject/upload"}
                            data={{ 'uid': this.props.data.uid, 'id': this.props.data.id, 'sign': 'tech_project' }}
                            beforeUpload={beforeUploadFile}
                            fileList={this.state.fileList}
                            onChange={(info) => {
                                if (info.file.status !== 'uploading') {
                                    console.log(info.file, info.fileList);
                                }
                                if (info.file.status === 'done') {
                                    if (!info.file.response.error.length) {
                                        message.success(`${info.file.name} 文件上传成功！`);
                                    } else {
                                        message.warning(info.file.response.error[0].message);
                                        return;
                                    };
                                    this.state.approvalUrl = info.file.response.data;
                                } else if (info.file.status === 'error') {
                                    message.error(`${info.file.name} 文件上传失败。`);
                                }
                                this.setState({ fileList: info.fileList.slice(-1) });
                            }}
                        >
                            <Button><Icon type="upload" /> 项目材料上传 </Button>
                        </Upload>
                        <p style={{ marginTop: '10px' }}>{theData.approvalUrl ?
                            <span className="download-file">
                                <a onClick={techDownloadFile.bind(null, "/api/admin/techproject/download", this.state.data.id)}>项目材料</a>
                                <a onClick={() => {
                                    var newTab = window.open('about:blank'); getPreview(theData.id, 'techProject', 'tech_project', function (data) { newTab.location.href = data; });
                                }}><Icon style={{ fontSize: '16px' }} type="eye-o" /> </a>
                            </span>
                            : <span><Icon type="exclamation-circle" style={{ color: '#ffbf00', marginRight: '6px' }} />未上传！</span>}</p>
                    </div>
                    <FormItem style={{ marginTop: '20px' }}>
                        <Button className="set-submit" type="primary" htmlType="submit">保存</Button>
                        <Button type="ghost" style={{ marginLeft: '20px' }} onClick={this.props.closeModal}>取消</Button>
                    </FormItem>
                </Form >
            );
        } else {
            return (<div></div>)
        };
    },
}));

const ApplyChange = React.createClass({
    getInitialState() {
        return {
            visible: false,
            loading: false
        };
    },
    componentWillReceiveProps(nextProps) {
        this.state.visible = nextProps.showDesc
    },
    showModal() {
        this.setState({
            visible: true,
        });
    },
    handleOk() {
        this.setState({
            visible: false,
        });
        this.props.closeDesc(false, true);
    },
    handleCancel(e) {
        this.setState({
            visible: false,
        });
        this.props.closeDesc(false);
    },
    spinChange(e) {
        this.setState({
            loading: e
        });
    },
    render() {
        return (
            <div className="patent-addNew">
                <Modal maskClosable={false} title="编辑科技项目" visible={this.state.visible}
                    onOk={this.handleOk} onCancel={this.handleCancel}
                    width='1000px'
                    footer='' >
                    <Spin spinning={this.state.loading} className='spin-box'>
                        <ApplyChangeFrom
                            visible={this.state.visible}
                            authorOption={this.props.authorOption}
                            data={this.props.data}
                            spinState={this.spinChange} closeModal={this.handleOk} />
                    </Spin>
                </Modal>
            </div>
        );
    }
});

export default ApplyChange;